﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Diagnostics;
using System.IO;

namespace CryptoCalc
{
    public partial class MainWindow : Window
    {
        private readonly Random rand = new();
        private List<Transaction> transactions = new();
        
        public MainWindow()
        {
            InitializeComponent();
        }

        private void saveButton_Click(object sender, RoutedEventArgs e)
        {
            DBInteraction.SaveTransaction(DummyTransaction());
        }
        private void saveButtonFromInput_Click(object sender, RoutedEventArgs e)
        {
            DBInteraction.SaveTransaction(new Transaction(inputCurrency.Text, Convert.ToSingle(inputAmount.Text), inputType.Text));
        }

        private void readButton_click(object sender, RoutedEventArgs e)
        {
            transactions = DBInteraction.LoadTransactions();
            foreach (Transaction x in transactions)
            {
                Debug.WriteLine($"{x.DateTimeString} *** {x.CryptoCurrency} - {x.Amount}");

            }
            //Debug.WriteLine(DateTime.Now.Minute.ToString());
        }
        private void searchButton_Click(object sender, RoutedEventArgs e)
        {
            transactions = DBInteraction.LoadTransactionsOfCurrency(currencyText.Text);
            transactionsFoundListBox.Items.Clear();
            foreach (Transaction x in transactions)
            {
                transactionsFoundListBox.Items.Add(x.FullInfo);
            }
        }


        private Transaction DummyTransaction()
        {
            Transaction t = new();
            t.Date_Year = DateTime.Now.Year;
            t.Date_Month = DateTime.Now.Month;
            t.Date_Day = DateTime.Now.Day;
            t.Time_Hour = DateTime.Now.Hour;
            t.Time_Minute = DateTime.Now.Minute;
            t.Time_Second = DateTime.Now.Second;
            t.DateTimeString = DateTime.Now.ToString();
            t.CryptoCurrency = "SOL";
            t.Amount = Convert.ToSingle(30*rand.NextDouble());
            t.TransactionType = "DEPOSIT";
            t.Service = "MiraiEx";
            t.Comment = "Test";
            return t;
        }

    }
}
